'''                                                           
    This program is free software; you can redistribute it and/or modify      
    it under the terms of the GNU General Public License as published by      
    the Free Software Foundation; either version 2 of the License, or         
    (at your option) any later version.                                       
                                                                            
    This program is distributed in the hope that it will be useful,           
    but WITHOUT ANY WARRANTY; without even the implied warranty of            
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             
    GNU Library General Public License for more details.                      
                                                                            
    You should have received a copy of the GNU General Public License     
    along with this program; if not, write to the 
    Free Software Foundation, Inc.,                                       
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             

    Sischema s.r.l.
    via Sebenico, 22
    20124 Milano - Italia
    tel-fax: (+39)0266823882
--------------------------------------------------------------------------------
'''

__version__ = "0.0.1"
__author__  = "Oreste Notelli <oreste.notelli@sischema.com>"


import feeds
import extractors
import GNUsTicker

class type:
    def __init__(self):
        self.properties = \
        {\
            "name": str("New Name"),
            "refresh": int(1200),
            "host": str(),
            "user": str(),
            "pass": str()
        }
    def create_instance(self, properties =None):
        if (properties == None): 
            return feed(self.name, self.properties.copy())
        else:
            return feed(self.name, properties)

import gtk
class element (GNUsTicker.news):
    def __init__(self, title, description, link, message):
        GNUsTicker.news.__init__(self,title,  link, description)
        self.__message = message
    def action(self):
        try:
            start_body = False
            message = ""
            for line in self.__message:
                if (line == ""):
                    start_body = True
                else:
                    if (start_body and len (message) < 512) :
                        message +=line + "\n"
            m = gtk.MessageDialog(message_format=message, buttons=gtk.BUTTONS_CLOSE)
            m.run()
            m.destroy()
        except Exception ,e:
            print (e)
       
import poplib

class feed(feeds.feed):
    def __init__(self, type_name, dictionary):
        feeds.feed.__init__(  self, 
                        name = dictionary["name"], 
                        link=None, 
                        timer = dictionary["refresh"]*1000)
        d = dictionary
        self.properties = d
        self.type_name = type_name
    def parse(self):
        print("parsing")
        pop = poplib.POP3(self.properties['host'])
        elements = []
        try:
            pop.user(self.properties['user'])
            pop.pass_(self.properties['pass'])
            numMessages = len(pop.list()[1])
            for i in range(numMessages):
                message = pop.retr(i+1)[1]
                title = ''
                description =''
                for line in message:
                    try:
                        ind = line.find(':')
                        header = line[:ind].strip()
                        value = line[ind+1:].strip()
                    except Exception:
                        header = ''
                        value = line
                    if header =='Subject': 
                        title = value
                    if header =='From':
                        description = value    
                print (title,description)
                elements.append(element(title, description, "", message))
        except Exception, e:
            print (e)
        pop.quit()
        print (elements)
        print("parsed")
        return feeds.product (self.name(), self.name(), self.link(), elements)


