#!/usr/bin/env python

'''
--------------------------------------------------------------------------------
    Copyright  (C) 2004, Oreste Notelli <oreste.notelli@sischema.com>          
                                                                            
    This program is free software; you can redistribute it and/or modify      
    it under the terms of the GNU General Public License as published by      
    the Free Software Foundation; either version 2 of the License, or         
    (at your option) any later version.                                       
                                                                            
    This program is distributed in the hope that it will be useful,           
    but WITHOUT ANY WARRANTY; without even the implied warranty of            
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             
    GNU Library General Public License for more details.                      
                                                                            
    You should have received a copy of the GNU General Public License     
    along with this program; if not, write to the 
    Free Software Foundation, Inc.,                                       
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             

    Sischema s.r.l.
    via Sebenico, 22
    20124 Milano - Italia
    tel-fax: (+39)0266823882
--------------------------------------------------------------------------------
'''

__version__ = "0.0.1"
__author__  = "Oreste Notelli <oreste.notelli@sischema.com>"

import feeds
import GNUsTicker

class type:
    def __init__(self):
        self.properties = \
        {\
            "name": str("New Name"),
            "refresh": int(1200),
            "url": str()
        }
    def create_instance(self, properties =None):
        if (properties == None): 
            return feed(self.name,self.properties.copy())
        else:
            return feed(self.name,properties)

import feedparser
import extractors
import GNUsTicker
import os

class element (GNUsTicker.news):
    def __init__(self, title, link, description):
        GNUsTicker.news.__init__(self, str(title), str(description))
        self.link = link
    def action(self):
        try:
            #d = self.__box.window
            #d.set_cursor(gtk.gdk.Cursor(gtk.gdk.WATCH))
            os.spawnlp(os.P_WAIT, "gnome-open",  str(self.link), str(self.link))
            #d.set_cursor(None)
        except Exception ,e:
            print (e)

class feed(feeds.feed):
    def __init__(self, type_name, dictionary):
        feeds.feed.__init__(  self, 
                        name = dictionary["name"], 
                        timer = dictionary["refresh"]*1000)
        d = dictionary
        self.__url_to_parse = d["url"]
        self.properties = d
        self.__type = type()
        self.type_name = type_name
    def parse(self):
        d = feedparser.parse(self.__url_to_parse)
        try:
            _link = d.feed.link
        except AttributeError:
            pass
        elems = d.entries
        elements = []
        for elem in elems:
            title = extractors.html_cleaner(elem.title, 0, len (elem.title))
            try:
                description = extractors.html_cleaner(elem.description, 
                                                   0, len (elem.description))
            except:
                description = elem.title
            link = elem.link
            e = element(title, link, description)
            elements.append(e)
        return feeds.product (self.name(), d.feed.title, elements)



