#!/usr/bin/env python
'''
-------------------------------------------------------------------------------
    Copyright  (C) 2004, Oreste Notelli <oreste.notelli@sischema.com>          
                                                                            
    This program is free software; you can redistribute it and/or modify      
    it under the terms of the GNU General Public License as published by      
    the Free Software Foundation; either version 2 of the License, or         
    (at your option) any later version.                                       
                                                                            
    This program is distributed in the hope that it will be useful,           
    but WITHOUT ANY WARRANTY; without even the implied warranty of            
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             
    GNU Library General Public License for more details.                      
                                                                            
    You should have received a copy of the GNU General Public License     
    along with this program; if not, write to the 
    Free Software Foundation, Inc.,                                       
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             

    Sischema s.r.l.
    via Sebenico, 22
    20124 Milano - Italia
    tel-fax: (+39)0266823882
-------------------------------------------------------------------------------
'''

__version__ = "0.2.1"
__author__  = "Oreste Notelli <oreste.notelli@sischema.com>"

from parser import * 
from utils import * 
import configuration
#from gnosis.xml import pickle 
#import xml.marshal.generic


html_feed_properties = \
{\
    "name": str("New Name"),
    "refresh": int(120),
    "url": str(),
    "rules" : str()
}

rss_feed_properties = \
{\
    "name": str("New Name"),
    "refresh": int(120),
    "url": str()
}

###############################################################################
class product:
    def __init__(self, feed_name, title = None, elements = None):
        self.feed_name = feed_name
        self.title = title
        self.elements = elements
    def __str__(self):
        return str(self.dict)
    def __str__(self):
        result= str("title="+ str(self.title)+
                    "\nelements:\n[\n")
        for elem in self.elements:
            result+= str(elem)
            result+= "\n"
        result+="\n]"
        return result

class feed:
    def __init__(self, name = None, timer = 120000):
        self.__name = name
        self.__timer = timer
    def name(self): return self.__name
    def timer(self): return self.__timer
    def __repr__(self):
        return self.__str__()
    def __str__(self):
        return  'feed ' + str(self.__name)

###############################################################################
    
class html_feed(feed):
    def __init__(self, dictionary):
        feed.__init__(  self, 
                        name = dictionary["name"], 
                        link=dictionary["url"], 
                        timer = dictionary["refresh"]*1000)
        d = html_feed_properties.copy()
        d.update (dictionary)
        self.__url_to_parse = d["url"]
        self.__rule = d["rules"]
        self.properties = d
        self.__type = html_feed_type()
        self.type_name = self.__type.name
    def parse(self):
        request = urllib2.Request(self.__url_to_parse)
        # pretend to be a common Mozilla web browser
        request.add_header('User-Agent',
                           'Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.7)'+
                           ' Gecko/20040715')
        body = urllib2.urlopen(request).read()
        p = product(self.name(), self.name(), self.link(),
                    process_rule(eval (self.__rule), body))
        return p

###############################################################################
# Examples

class html_feed_type:
    def __init__(self):
        #parser_type.__init__(self, "html_feed", html_feed_properties)
        pass

import os

__plugin_package ="feed_plugins"

def __python_source(filename):
    return filename[-3:] == ".py"

def __exclude_init(filename):
    return filename != "__init__.py"

def __extract_plugin_name(filename):
    return filename[:-3]

import feed_plugins
import globaldata
def types():
    plugin_list = os.listdir(globaldata.feeds_dir)
    result =[]
    for plugin_file in filter(__exclude_init, \
                       filter(__python_source, plugin_list)):
        plugin_name = __extract_plugin_name(plugin_file)
        print ("found pluglin :"+plugin_name)
        __import__(__plugin_package +"." +plugin_name)
        feed_type = eval(__plugin_package +"." +plugin_name+ ".type()")
        feed_type.name=plugin_name;
        result.append(feed_type)
    return result
    

google_news_rule =   """cyclic_rule('news',
                simple_match_rule('__ignore__', 'html', 'script>'),
                simple_match_rule('__ignore__', '</html>', ''),
                set_rules('elem',
                    [simple_match_rule ('__ignore__', '</table><a', 'href'),
                     simple_match_rule ('link', '="', '"'),
                     simple_match_rule ('title', '>', '</a>', composite([html_cleaner, ascii])), 
                     simple_match_rule ('__ignore__', '<br><font size=-1>', 
                                        '</font>'),
                     simple_match_rule ('description', '<br><font size=-1>', 
                                        '</font>',
                                        composite([trimmer, html_cleaner, ascii]))
                        
                    ]))"""

google_news_italia_url = "http://news.google.it/nwshp?hl=it&gl=it"

google_news_USA_url = "http://news.google.it/nwshp?hl=en&ned=us"

defaults_feeds = []
#         rss_feed(  {'name':"ZDNetNews","url": "http://news.zdnet.com/2509-1_22-0-20.xml",
#                     'refresh':120}),
#         html_feed( {'name':"Google News Italia", 
#                     "url":google_news_italia_url,
#                     'refresh':120,
#                     "rules":google_news_rule}),
#         html_feed( {'name':"Google News USA",  
#                     "url": google_news_USA_url,
#                     'refresh':120,
#                      "rules": google_news_rule})
#        ]


def get_default_feeds():
    return defaults_feeds

def get_feeds(configuration):
    __feeds = get_avaible_feed_list(configuration)
    if len (__feeds) == 0:
        __feeds = defaults_feeds[:]
    return __feeds


import feeds_configuration;# import COLUMN_ENABLED, COLUMN_NAME, COLUMN_EDITABLE, COLUMN_TYPE

def build_feed(serialized_feed):
    import feed_plugins
    return eval ("feed_plugins."+serialized_feed.type_name +".feed('"+serialized_feed.type_name+ "', "+str(serialized_feed.properties) +")");

def get_avaible_feed_list(configuration):
    feedlist = []
    l = configuration.load("feeds")
    for row in l:
        if row[feeds_configuration.COLUMN_ENABLED] == gtk.TRUE:
            feed = row[feeds_configuration.COLUMN_TYPE]
            f = build_feed(feed)
            feedlist.append(f)
    return feedlist

################################################################################

if (__name__ == "__main__"):
    import sys
    feeds = get_feeds(configuration.homedirXMLfileconfiguration("GNUsTicker"))
    for feed in feeds:
        print "****************************************************************"
        print "name " + str(feed.name())
        news = feed.parse().elements
        print "----------------------------------------------------------------"
        for elem in news:
            print "------------------------------------------------------------"
            print (elem.title)
            print "----"
            print (elem.description)
            pass

################################################################################
