#!/usr/bin/env python
'''
-------------------------------------------------------------------------------
    Copyright  (C) 2004, Oreste Notelli <oreste.notelli@sischema.com>          
                                                                            
    This program is free software; you can redistribute it and/or modify      
    it under the terms of the GNU General Public License as published by      
    the Free Software Foundation; either version 2 of the License, or         
    (at your option) any later version.                                       
                                                                            
    This program is distributed in the hope that it will be useful,           
    but WITHOUT ANY WARRANTY; without even the implied warranty of            
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             
    GNU Library General Public License for more details.                      
                                                                            
    You should have received a copy of the GNU General Public License     
    along with this program; if not, write to the 
    Free Software Foundation, Inc.,                                       
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             

    Sischema s.r.l.
    via Sebenico, 22
    20124 Milano - Italia
    tel-fax: (+39)0266823882
-------------------------------------------------------------------------------
'''

__version__ = "0.1.1"
__author__  = "Oreste Notelli <oreste.notelli@sischema.com>"

import pygtk
#pygtk.require('2.0')
import bonobo
import gtk
import sys
import gnome
import gobject
import gnome.applet
import gnome.ui
import gtkhtml2
import os
import feeds
import utils
import configuration
import globaldata
import widgets
#import scrolling
#import emptywidget

###############################################################################

product_name = 'GNUsTicker'
product_version = globaldata.product_version
product_icon_file_name= globaldata.product_icon_file_name
product_licence = "2004 (c) Oreste Notelli <oreste.notelli@sischema.com>"
product_author = "Oreste Notelli <oreste.notelli@sischema.com>"
product_description = "News Ticker Applet for Gnome Panel"

###############################################################################

def get_feeds(conf):
    '''
        returns a list of feed
    '''
    return feeds.get_feeds(conf)

###############################################################################

class applet:

    def __init__(self, parent_applet, session_key):
        # product icon
        self.icon = utils.file_icon_extractor(product_icon_file_name)
        self.parent_applet = parent_applet
        self.timers = dict()

        # read configuration
        self.__config_filename = "applet"
        self.__configuration = configuration.\
                                homedirXMLfileconfiguration(\
            os.path.join("GNUsTicker",session_key))
        self.__conf = self.__configuration.load(self.__config_filename, 
                                                {"applet with":150})
        self.__create_newswidget()

        # create applet menu
        self.__propxml='\
        <popup name="button3"> \
            %s\
            <menuitem name="Item 0" verb="Feeds" label="_Configure Feeds..." \
                      /> \
            <separator/> \
            <menuitem name="Item 1" verb="Props" label="_Preferences..." \
                      pixtype="stock" pixname="gtk-properties"/> \
            <menuitem name="Item 2" verb="About" label="_About..." \
                      pixtype="stock" pixname="gnome-stock-about"/> \
           </popup>'
        self.verbs = [  ("Props", self.__properties ), 
                        ("About", self.__about_info ),
                        ("Feeds", self.__configure_feeds)]

        # create athe widget that will show the news.
        self.parent_applet.connect("size_request", self.size_request)
        self.parent_applet.setup_menu(self.__propxml %'',self.verbs,None)
        self.parent_applet.show_all()

        #get the feeds
        print "get the feeds..."
        try:
            self.__read_feeds()
        except:
            pass
        print "applet init"

    ###########################################################################

    def __read_feeds(self):
        print "__read_feeds"
        feeds = get_feeds(self.__configuration)
        self.__newswidget.remove_all_products()
        self.__feeds = dict()
        for feed in feeds:
            print "__read_feeds adding... "+feed.name()
            self.__feeds[feed.name()] = feed            
            self.__set_timer_once(feed.name(), 2000)
            self.__set_timer(feed.name(), feed.timer())
        print "__read_feeds end"
    
    ###########################################################################

    def __create_newswidget(self):
        #module = self.__conf['widget']
        module = 'scrolling'
        __import__("widgets."+module)
        self.__newswidget = eval ('widgets.'+module+'.'+'news_widget()')
        widget_conf = self.__newswidget.get_configuration()
        self.__component_properties_filename = \
                                       self.__newswidget.__class__.__module__+\
                                       "."+ \
                                       self.__newswidget.__class__.__name__
        print ("component_properties_filename= "+ \
			   self.__component_properties_filename)
        self.__newswidget.set_configuration( 
                          self.__configuration.load(
                                        self.__component_properties_filename,
                                        widget_conf))
        print (widget_conf)
        self.__newswidget.activate(self, self.parent_applet)

    ###########################################################################
    
    def __set_timer (self, name, timer):
        try:
            timer_id = self.timers[name]
            gobject.source_remove(timer_id)
        except KeyError:
            pass
        self.timers[name]=gobject.timeout_add(timer, self.__update_feed, name)
        print ("set time for..." + name)

    ###########################################################################
        
    def setup_menu(self, xml, verbs):
        #merge the widget and the container menu
        newverbs = self.verbs[:]
        newverbs.extend(verbs)
        self.parent_applet.setup_menu(self.__propxml %xml,newverbs,None)

    ###########################################################################
                
    def __set_timer_once (self, name, timer):
        gobject.timeout_add(timer, self.__update_feed_once, name)

    ###########################################################################

    def size_request(self, widget, requisition):
        print "size_request"
        requisition.width = self.__conf['applet with']
        requisition.height = widget.get_size()

    ###########################################################################

    def __update_feed_once (self, feed_name):
        self.__update_feed(feed_name)
        return gtk.FALSE

    ###########################################################################
    
    def __update_feed (self, feed_name):
        try:
            print ("updating feed..." +feed_name)
            feed = self.__feeds[feed_name]
            product = feed.parse()
            self.__newswidget.set_feed_product(product)
            print ("updated feed..." +feed_name)
        except Exception, e:
            print (e)
        return  gtk.TRUE

    ###########################################################################

    def __properties(self, event,data=None):
        self.__mergedconf = utils.merge_dictionary(self.__conf,
                                                   self.__newswidget\
                                                   .get_configuration())
        configuration.gtk_dialog_input( self.__mergedconf, 
                                        self.__properties_changed, 
                                        self.icon())

    ###########################################################################

    def __configure_feeds(self, event,data=None):
        import feeds_configuration
        feeds_configuration.feeds_config_dialog(
            self.__configuration, 
            self.icon(), 
            self.__read_feeds)

    ###########################################################################
        
    def __properties_changed(self):
        print (self.__mergedconf)
        utils.updatedictionary(self.__conf, self.__mergedconf)
        utils.updatedictionary(self.__newswidget.get_configuration(),
                               self.__mergedconf)
        self.__configuration.save( self.__config_filename, self.__conf)
        self.__newswidget.on_configuration_changed();
        self.__configuration.save( self.__component_properties_filename, 
                            self.__newswidget.get_configuration_to_save())
        print (dir(self.__newswidget))
        #self.__newswidget.remove()
        #self.__create_newswidget()
        
    ###########################################################################

    def __about_info(self, event,data=None):
        about = gnome.ui.About(product_name,product_version,product_licence,
                product_description,
                [product_author],[],None,self.icon())
        about.set_icon (self.icon())
        about.show()

global main_applet

###############################################################################

def gnus_factory(parent_applet, iid):
    session_key = parent_applet.get_preferences_key()
    main_applet = applet(parent_applet,session_key[1:])
    return gtk.TRUE

###############################################################################

def quit(window):
    gtk.main_quit()

###############################################################################

# if program is called with the "run-in-window" option, it must work out of the
# panel
if ((len(sys.argv) == 3 and
     sys.argv[1] == "run-in-window") or
    (len(sys.argv) == 1)):
    print ("starting..")
    if (len(sys.argv) == 3):
        session_key = sys.argv[2]
    else:
        session_key = "main"
    
    #initialize gnome
    gnome.init(product_name, product_version)
    # create a main window
    main_window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    main_window.set_title(product_name)
    main_window.connect("destroy", quit)
    pixbuf = gtk.gdk.pixbuf_new_from_file(product_icon_file_name)
    main_window.set_icon(pixbuf)
    app = gnome.applet.Applet()
    main_applet = applet(app,session_key)
    app.reparent(main_window)
    main_window.show_all()
    gtk.main()
else:
    gnome.applet.bonobo_factory("OAFIID:GNOME_GNUsTicker_Factory", 
                             gnome.applet.Applet.__gtype__, 
                             product_name, "0", gnus_factory)
