#!/usr/bin/env python
'''
--------------------------------------------------------------------------------
    Copyright  (C) 2004, Oreste Notelli <oreste.notelli@sischema.com>          
                                                                            
    This program is free software; you can redistribute it and/or modify      
    it under the terms of the GNU General Public License as published by      
    the Free Software Foundation; either version 2 of the License, or         
    (at your option) any later version.                                       
                                                                            
    This program is distributed in the hope that it will be useful,           
    but WITHOUT ANY WARRANTY; without even the implied warranty of            
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             
    GNU Library General Public License for more details.                      
                                                                            
    You should have received a copy of the GNU General Public License     
    along with this program; if not, write to the 
    Free Software Foundation, Inc.,                                       
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             

    Sischema s.r.l.
    via Sebenico, 22
    20124 Milano - Italia
    tel-fax: (+39)0266823882
--------------------------------------------------------------------------------
'''
__version__ = "0.1.0"
__author__  = "Oreste Notelli <oreste.notelli@sischema.com>"

import gtk
class file_icon_extractor:
    def __init__(self, file_name):
        self.__file_name = file_name
        self.__pixbuffer = None
    def __call__(self):
        if (self.__pixbuffer == None):
            self.__pixbuffer = gtk.gdk.pixbuf_new_from_file(self.__file_name)
        return self.__pixbuffer


def create_menu(options, activator, active_index = 0):
    '''
    Create a menu from the given options (string container) and the activator 
    that is the callback function that will be called when menu is activated
    activator prototype:
    activator(optionName
    '''
    menu = gtk.Menu()
    for str in options:
        menu_item = gtk.MenuItem(str)
        menu_item.show()
        menu_item.connect("activate", activator, str)
        gtk.MenuShell.append(menu, menu_item)
    menu.set_active(active_index)
    return menu

def empty_callback(value):
    pass

class selector:
    def __init__(self, items, selected = 0, callback= empty_callback):
        self.__items = items
        self.__active_index = selected
        self.selected= items[0]
        self.__callback = callback
    def get_widget(self):
        optionmenu = gtk.OptionMenu()
        optionmenu.set_menu(create_menu(self.__items, self.on_selected, self.__active_index))  
        return optionmenu
    def on_selected (self, item, value):
        self.selected = value
        self.__callback(value)
