#!/usr/bin/env python
'''
--------------------------------------------------------------------------------
    Copyright  (C) 2004, Oreste Notelli <oreste.notelli@sischema.com>          
                                                                            
    This program is free software; you can redistribute it and/or modify      
    it under the terms of the GNU General Public License as published by      
    the Free Software Foundation; either version 2 of the License, or         
    (at your option) any later version.                                       
                                                                            
    This program is distributed in the hope that it will be useful,           
    but WITHOUT ANY WARRANTY; without even the implied warranty of            
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             
    GNU Library General Public License for more details.                      
                                                                            
    You should have received a copy of the GNU General Public License     
    along with this program; if not, write to the 
    Free Software Foundation, Inc.,                                       
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             

    Sischema s.r.l.
    via Sebenico, 22
    20124 Milano - Italia
    tel-fax: (+39)0266823882
--------------------------------------------------------------------------------
'''
__version__ = "0.1.1"
__author__  = "Oreste Notelli <oreste.notelli@sischema.com>"

import os
import sys
import shutil
import string

def already_in_path(path_variable, directory):
    path_found = False
    try:
        pathstring = os.environ[path_variable]
        path_dirs = string.split(pathstring, ':')
        path_found = False
        for path_dir in path_dirs:
            if (path_dir == directory):
                path_found = True
                break
    except KeyError:
        pass
    return path_found

def check_requirements():
    # TO DO: check if all required software is installed
    return True    

if not check_requirements():
    print "Setup failed"
    sys.exit(1)

if (len(sys.argv) != 2):
    install_dir=raw_input("Installation dir (es: /usr): ")
else:
    install_dir=sys.argv[1]
    
binaries_dir = os.path.join (install_dir, 'bin')
bonobo_server_dir = os.path.join (install_dir, 'lib', 'bonobo', 'servers')
base_dir = os.path.join (install_dir, 'share','GNUsTicker')
data_dir = os.path.join (install_dir, 'share','GNUsTicker', 'data')

home_dir = os.environ['HOME']
bash_profile_name = os.path.join (home_dir , '.bash_profile')
reboot = False        
bash_profile = open(bash_profile_name, "r")
content = bash_profile.read()
if not already_in_path('BONOBO_ACTIVATION_PATH', bonobo_server_dir):
    reboot = True
    content =   content + "\nexport BONOBO_ACTIVATION_PATH=" + \
                bonobo_server_dir + ":$BONOBO_ACTIVATION_PATH\n"

if not already_in_path('PATH', binaries_dir):
    reboot = True
    content = content + "\nexport PATH="+binaries_dir+":$PATH\n"
    
shutil.copyfile(bash_profile_name, bash_profile_name + '.bak')
bash_profile = open(bash_profile_name, "w")
bash_profile.write(content)

shutil.copyfile(bash_profile_name, bash_profile_name + '.bak')
server_file_in = open("GNOME_GNUsTicker.server.in")
server_content =  server_file_in.read()
server_content = server_content%(binaries_dir, data_dir)
server_file = open("GNOME_GNUsTicker.server", "w")
server_file.write(server_content)
server_file.close()

globaldata_file_in = open("globaldata.py.in")
globaldata_content =  globaldata_file_in.read()
globaldata_content = globaldata_content%(install_dir)
globaldata_file_in.close()
globaldata_file = open("globaldata.py", "w")
globaldata_file.write(globaldata_content)
globaldata_file.close()

files = ["configuration.py",
"extractors.py",
"feedparser.py",
"feeds_configuration.py",
"feeds.py",
"globaldata.py",
"gnusapplet.py",
"parser.py",
"setup.py",
"utils.py"]

if not os.path.exists(base_dir): os.makedirs(base_dir)

for file in files: shutil.copy(file, base_dir)

if not os.path.exists(binaries_dir): os.makedirs(binaries_dir)
try:
    os.remove(os.path.join(binaries_dir, "gnusapplet"))
except OSError:
    pass
os.symlink( os.path.join(base_dir, "gnusapplet.py"), 
            os.path.join(binaries_dir, "gnusapplet"))

if not os.path.exists(bonobo_server_dir): os.makedirs(bonobo_server_dir)
shutil.copy("GNOME_GNUsTicker.server", bonobo_server_dir)

if not os.path.exists(data_dir): os.makedirs(data_dir)
shutil.copy("gnome-news.png", data_dir)

print "Setup successfully termitated."
if (reboot == True): print "Now you can reboot your PC"
