#!/usr/bin/env python
'''
--------------------------------------------------------------------------------
    Copyright  (C) 2005, Oreste Notelli <oreste.notelli@sischema.com>          
                                                                            
    This program is free software; you can redistribute it and/or modify      
    it under the terms of the GNU General Public License as published by      
    the Free Software Foundation; either version 2 of the License, or         
    (at your option) any later version.                                       
                                                                            
    This program is distributed in the hope that it will be useful,           
    but WITHOUT ANY WARRANTY; without even the implied warranty of            
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             
    GNU Library General Public License for more details.                      
                                                                            
    You should have received a copy of the GNU General Public License     
    along with this program; if not, write to the 
    Free Software Foundation, Inc.,                                       
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             

    Sischema s.r.l.
    via Sebenico, 22
    20124 Milano - Italia
    tel-fax: (+39)0266823882
--------------------------------------------------------------------------------
'''
__version__ = "0.0.1"
__author__  = "Oreste Notelli <oreste.notelli@sischema.com>"

import gtk
import gtk.gdk
import GNUsTicker
import os
import globaldata

LEFT_BUTTON = 1

class news_widget:
    def __init__(self):
        self.__configuration = {'mail reader':'evolution'}

    def activate(self, applet, container):
        self.__applet = applet
        self.__container = container
        self.__image = gtk.Image()
        self.__tooltips = gtk.Tooltips()
        ev = gtk.EventBox()
        ev.add(self.__image)
        ev.connect("button_press_event", self.__onclick)
        self.__image.set_from_file(
            os.path.join(globaldata.images_dir,'mail_empty.png'))
        self.__tooltips.set_tip(self.__container, "no mail")
        container.add(ev)
        self.__event = ev
        container.show_all()
        print("__control_created")
        
    def set_feed_product(self, product):
        self.__product = product
        mail_count = len (self.__product.elements)
        if (mail_count != 0):
            self.__image.set_from_file(
                os.path.join(globaldata.images_dir,'mail_generic.png'))
            if (mail_count == 1):
                self.__tooltips.set_tip(self.__container,
                                        "(" + str(mail_count)+")mail")
            else:
                self.__tooltips.set_tip(self.__container,
                                        "(" + str(mail_count)+")mails")
        else:
            self.__image.set_from_file(
                os.path.join(globaldata.images_dir,'mail_empty.png')) 
            self.__tooltips.set_tip(self.__container, "no mail")
        
    
    def set_configuration(self, newconf):
        pass
    
    def get_configuration(self):
        return self.__configuration
        pass

    def get_configuration_to_save(self):
        return self.get_configuration()

    def remove_all_products(self):
        pass

    def on_configuration_changed(self):
        pass

    def remove (self):
        self.__container.remove(self.__event)

    def __onclick(self, a, b):
        if ((b.button == LEFT_BUTTON) and (b.type == gtk.gdk._2BUTTON_PRESS)):
            os.spawnlp(os.P_NOWAIT,
                       self.__configuration['mail reader'],
                       self.__configuration['mail reader'])
            print "click"

