/*
--------------------------------------------------------------------------------
    Copyright  (C) 2004, Oreste Notelli <oreste.notelli@sischema.com>          
                                                                            
    This program is free software; you can redistribute it and/or modify      
    it under the terms of the GNU General Public License as published by      
    the Free Software Foundation; either version 2 of the License, or         
    (at your option) any later version.                                       
                                                                            
    This program is distributed in the hope that it will be useful,           
    but WITHOUT ANY WARRANTY; without even the implied warranty of            
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             
    GNU Library General Public License for more details.                      
                                                                            
    You should have received a copy of the GNU General Public License     
    along with this program; if not, write to the 
    Free Software Foundation, Inc.,                                       
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             

    Sischema s.r.l.
    via Sebenico, 22
    20124 Milano - Italia
    tel-fax: (+39)0266823882
--------------------------------------------------------------------------------
*/
#include "scrollingframe.hh"

namespace GtkExtensions 
{

ScrollingFrame&    
ScrollingFrame::set_news_page(newspage& news_arg)
{
/*
    if (_news.find(news_arg.title) == _news.end())
    {
        printf (  "ScrollingFrame::set_news_page  news_arg.title = %s\n", 
                  news_arg.title.c_str());
        for (newspage::iterator it = news_arg.begin();
             it != news_arg.end();
             it++)
        {
            printf ("ScrollingFrame::set_news_page %s\n", 
                    it->title.c_str());
            _scroll.add_part(new part(_event,
                                      _tooltips, 
                                      *it,
                                      callback_ptr(this)));
        }
    }
*/
    _news[news_arg.title]= news_arg;
    return (*this);
}

void ScrollingFrame::remove_all_feeds()
{
    _news.clear();
}

void ScrollingFrame::restart()
{
    printf("ScrollingFrame::restart()\n");
    _scroll.reset();
    for (std::map<std::string, GtkExtensions::newspage>::iterator mapIter = 
	   _news.begin();
       mapIter != _news.end();
       ++mapIter)
    {        
        for (newspage::iterator it = mapIter->second.begin();
                 it != mapIter->second.end();
                 it++)
        {
            _scroll.add_part(new part(_event,
                                      _tooltips, 
                                      *it));
        }
    }
}

}
